SystemOrganization addCategory: #'SourceCity-OpenGL'!

!NBGLDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:27'!
readPixel: aPoint

      |  x y pixel |
	pixel := ByteArray new: 4.

	x := aPoint x asInteger.
	y := aPoint y asInteger.
	
	"Copy pixels from buffer into a form"
	self gl flush;
		pixelStorei_pname: GL_PACK_SKIP_ROWS param: 0;
		pixelStorei_pname: GL_PACK_SKIP_PIXELS param: 0;
		
		readPixels_x: x
		y: y
		width: 1  
		height: 1  
		format: GL_BGRA_EXT 
		type:  GL_UNSIGNED_BYTE 
		pixels: pixel.

	^ pixel
	! !

!NBMSAAOffscreenDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:35'!
readPixel: aPoint
	| r |

	renderFBO bindAsReadBuffer.
	resultsFBO bindAsDrawBuffer.
	
	self gl blitFramebuffer_srcX0: 0 srcY0:  0 srcX1: extent x srcY1: extent y 
		dstX0:  0 dstY0:  0 dstX1: extent x  dstY1: extent y mask: GL_COLOR_BUFFER_BIT filter: GL_NEAREST.
	
	resultsFBO bindAsReadBuffer.
		
	r := super readPixel: aPoint.
	^ r! !

GLViewportMorph subclass: #SourceCityGL
	instanceVariableNames: 'importer configuration pickingBuf selectedElement informationDisplay camera controller drawing userInterface cityDimension glList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGL commentStamp: '<historical>' prior: 0!
A GLCity is a class which display the city with OpenGL, this class use camera and key handler!

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
camera
	^ camera! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
camera: anObject
	camera := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 7/3/2012 14:44'!
changeConfiguration: aCityConfiguration
	configuration := aCityConfiguration.
	self importer: configuration model.
	self createRenderingList.! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 16:47'!
cityDimension
	^ cityDimension! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 16:47'!
cityDimension: anObject
	cityDimension := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
configuration
	^ configuration! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
configuration: anObject
	configuration := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 16:09'!
controller
	^ controller! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 16:09'!
controller: anObject
	controller := anObject! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 7/3/2012 17:21'!
createRenderingList
	| gl |
	self glList: (display gl genLists: 1).
	(glList = 0)
	ifTrue: [self error: 'wrong declaration'] 
	ifFalse: [
		display bindRenderBuffers.
		self checkSession.
		self openglOption: true.
		gl := display gl.
		gl newList_list: glList mode: GL_COMPILE.
		display gl translatef_x: 0-((self cityDimension) first/2) asFloat y: 0 z: 0-((self cityDimension) second/2) asFloat.
		self cityDimension: (self drawing drawCity: self importer).
		gl endList.
		].! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 6/26/2012 16:35'!
disableOpenGLOption
	
	display gl 		
		enable: GL_MULTISAMPLE ;
		disable: GL_BLEND;
		disable: GL_POLYGON_SMOOTH;
		disable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.		! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/22/2012 15:39'!
display
	^ display! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:01'!
drawing
	^ drawing! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:01'!
drawing: anObject
	drawing := anObject! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 6/18/2012 11:34'!
enableOpenGLOption
	
	display gl 		
		enable: GL_MULTISAMPLE ;
		enable: GL_BLEND;
		enable: GL_POLYGON_SMOOTH;
		enable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		shadeModel: GL_SMOOTH;
		hint_target: GL_LINE_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_POLYGON_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_PERSPECTIVE_CORRECTION_HINT mode: GL_NICEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.		
	"save it there for the moment :)"
	"WORK !!!!!!!!"
	"specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 
	shinines:= GLFloatRGBA new.
	shinines r: 500. 	
	l_pos := GLFloatVector new.
	l_pos x: 0 ;y: 0;z: 0. 
	l_color := GLFloatRGBA new.
	l_color r: 1; g: 1;b: 1; a:1. 			
	lmodel_ambient := GLFloatRGBA new.
	lmodel_ambient r: 1;g: 1 ;b: 1; a:1."
	
	"fog_color := GLFloatRGBA new.
	fog_color r: 0.5; g: 0.5;b: 0.5; a:1. "
		
		"FOG"
		"enable: GL_FOG;
		fogi_pname: GL_FOG_MODE param: GL_EXP2;
		fogfv_pname: GL_FOG_COLOR params: fog_color;
		fogf_pname: GL_FOG_DENSITY param: 0.01;
		hint_target: GL_FOG_HINT mode: GL_DONT_CARE;
		fogf_pname: GL_FOG_START param: 1.0;
		fogf_pname: GL_FOG_END param: 5.0;"
		
		"LIGHT"
		"materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS  params: shinines;
		lightfv_light: GL_LIGHT0 pname: GL_POSITION params: l_pos;
		lightfv_light: GL_LIGHT0 pname: GL_DIFFUSE params: l_color;
		lightfv_light: GL_LIGHT0 pname: GL_SPECULAR params: l_color;
		lightModelfv_pname: GL_LIGHT_MODEL_AMBIENT params: lmodel_ambient;
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;	"
				
	! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 7/3/2012 12:06'!
glList
	^ glList! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 7/3/2012 12:06'!
glList: anObject
	glList := anObject! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:24'!
handleMouseMove: anEvent
	self controller handleMouseMove: anEvent
! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
handlesMouseOver: anEvent
	^ true! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
hasKeyboardFocus
	^true.! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:12'!
importer
	^ importer! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:12'!
importer: anObject
	importer := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
informationDisplay
	^ informationDisplay! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
informationDisplay: anObject
	informationDisplay := anObject! !

!SourceCityGL methodsFor: 'initialize' stamp: 'DouailleErwan 7/3/2012 16:43'!
initialize
	| fontPath |
	super initialize.
	
	self cityDimension: {0 . 0}.
	self configuration: SourceCityApi default.
	self camera: (SourceCityGLCamera initialize: self).
	self controller: (SourceCityGLController initialize: self).
	self drawing: (SourceCityGLDrawing initialize: self).
	self userInterface: (SourceCityUI initialize: self).
	
	self on: #keyStroke send: #captureKey: to: self controller.
	self on: #mouseDown send: #captureMouseDown: to: self controller.	
		
	! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
mouseEnter: anEvent
	anEvent hand newKeyboardFocus: self! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
mouseLeave: anEvent
	anEvent hand newKeyboardFocus: nil! !

!SourceCityGL methodsFor: 'initialize' stamp: 'DouailleErwan 6/25/2012 10:30'!
openInWorld
	|dock container win |
	self startStepping.
	self takeKeyboardFocus.
	self userInterface openInWorld.! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 6/18/2012 10:24'!
openglOption: aBoolean
	(aBoolean)
	ifTrue: [self enableOpenGLOption] 
	ifFalse: [self disableOpenGLOption]. ! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
pickingBuf
	^ pickingBuf! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
pickingBuf: anObject
	pickingBuf := anObject! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 7/3/2012 17:22'!
render
	display bindRenderBuffers.
	self checkSession.
	(self glList isNil)
	ifTrue: [self createRenderingList. ] 
	ifFalse: [
		display gl clearColor_red: configuration backgroundOpenGL red green:  configuration backgroundOpenGL green blue:  configuration backgroundOpenGL blue alpha: 0;
			clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT;
			matrixMode: GL_PROJECTION; 						
			loadIdentity.		
	
		self camera perspectiveFovY: 100.0  
			aspect: (self width /self height) asFloat  
			zNear: 0.1  
			zFar: 10000.0.
		
		display gl matrixMode: GL_MODELVIEW; 
			loadIdentity.
		self camera applyCamera.
		display gl
			callList: self glList;
			popMatrix;
			flush.].! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
selectedElement
	^ selectedElement! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
selectedElement: anObject
	selectedElement := anObject! !

!SourceCityGL methodsFor: 'initialize' stamp: 'DouailleErwan 7/2/2012 14:32'!
sourceCityApi: aSourceCityApi
	configuration := aSourceCityApi.
	self importer: configuration sourceCityImporter.! !

!SourceCityGL methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 6/18/2012 10:24'!
step
	self changed! !

!SourceCityGL methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 6/18/2012 10:24'!
stepTime
	^5! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 14:08'!
userInterface
	^ userInterface! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 14:08'!
userInterface: anObject
	userInterface := anObject! !

GLViewportMorph subclass: #SourceCityGLDrawing
	instanceVariableNames: 'pickingMode sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLDrawing commentStamp: '<historical>' prior: 0!
I manage how do render the city.!

!SourceCityGLDrawing class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/21/2012 13:57'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/28/2012 11:17'!
building: aBuilding array: anArray width: width height: height
	| x z y r g b id |
	(self pickingMode)
	ifTrue: [
		id := aBuilding id.
		r := id bitAnd: 255.
		g := id >> 8 bitAnd: 255.  " id // (2^8) "
		b := id >>16 bitAnd: 255.
		display gl color3ub_red:  r green: g  blue:  b.
		] 
	ifFalse: [
		(self selectedElement = aBuilding)
		ifTrue: [display gl color3f_red: 255 green: 255 blue: 255] 
		ifFalse: [display gl color3f_red: aBuilding color red green: aBuilding color green blue: aBuilding color blue.].
		].
	
	self drawCube: anArray x_width: width z_width: width height: height.
	(self pickingMode)
	ifFalse: [self drawBorder: anArray x_width: width z_width: width height: height.].! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/28/2012 11:25'!
city: aCity array: anArray  x_width: xwidth z_width: zwidth color: aColor
	(self pickingMode)
	ifTrue: [display gl color3f_red: 0 green: 0 blue: 0] 
	ifFalse: [display gl color3f_red: aColor red green: aColor green blue: aColor blue].
	
	self drawCube: anArray x_width: xwidth z_width: zwidth height: aCity height.
	
	(self pickingMode)
	ifFalse: [self drawBorder: anArray x_width: xwidth z_width: zwidth height: aCity height.].! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/28/2012 16:24'!
district: aDistrict array: anArray x_width: xwidth z_width: zwidth height: height
	| x z y r g b id |
	(self pickingMode)
	ifTrue: [
		id := aDistrict id.
		r := id bitAnd: 255.
		g := id >> 8 bitAnd: 255.  " id // (2^8) "
		b := id >>16 bitAnd: 255.
		display gl color3ub_red:  r green: g  blue:  b.
		] 
	ifFalse: [
		(self selectedElement = aDistrict)
		ifTrue: [display gl color3f_red: 255 green: 255 blue: 255] 
		ifFalse: [display gl color3f_red: aDistrict color red 
			green: aDistrict color green 
			blue: aDistrict color blue.].
		].
		
	self drawCube: anArray x_width: xwidth z_width: zwidth height: height.
	
	(self pickingMode)
	ifFalse: [self drawBorder: anArray x_width: xwidth z_width: zwidth height: height.].! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/28/2012 10:40'!
drawBack: anArray x_width: xwidth z_width: zwidth height: height
	display gl begin: GL_QUADS;
		vertex3d_x:  anArray first 
			y: anArray second 
			z: (anArray third)+zwidth;
		vertex3d_x:  (anArray first)+xwidth 
			y: anArray second 
			z: (anArray third)+zwidth;
		vertex3d_x:  (anArray first)+xwidth 
			y: anArray second + height
			z: (anArray third)+zwidth;
		vertex3d_x:  anArray first 
			y: anArray second + height
			z: (anArray third)+zwidth;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/28/2012 11:22'!
drawBorder: anArray x_width: xwidth z_width: zwidth height: height
	display gl begin: GL_LINE_STRIP;
		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: anArray first + xwidth
			y: anArray second 
			z: anArray third;
		vertex3f_x: anArray first + xwidth
			y: anArray second + height
			z: anArray third;
		vertex3f_x: anArray first + xwidth
			y: anArray second + height
			z: anArray third + zwidth;
		vertex3f_x: anArray first
			y: anArray second + height
			z: anArray third + zwidth;
		vertex3f_x: anArray first
			y: anArray second + height
			z: anArray third;
		vertex3f_x: anArray first
			y: anArray second
			z: anArray third;
		vertex3f_x: anArray first + xwidth
			y: anArray second
			z: anArray third;
		vertex3f_x: anArray first + xwidth
			y: anArray second
			z: anArray third+ zwidth;
		vertex3f_x: anArray first
			y: anArray second
			z: anArray third+ zwidth;
		vertex3f_x: anArray first
			y: anArray second
			z: anArray third;
	end.
	display gl begin: GL_LINES;
		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: anArray first
			y: anArray second + height
			z: anArray third;
		vertex3f_x: anArray first + xwidth
			y: anArray second + height
			z: anArray third;
		vertex3f_x: anArray first
			y: anArray second
			z: anArray third + zwidth;
		vertex3f_x: anArray first
			y: anArray second + height
			z: anArray third + zwidth;
		vertex3f_x: anArray first + xwidth
			y: anArray second
			z: anArray third + zwidth;
		vertex3f_x: anArray first + xwidth
			y: anArray second + height
			z: anArray third + zwidth;
		end.! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/26/2012 16:49'!
drawBuilding: aDistrict x: x z: z dxSize: dxSize
	| bxSize bzSize zmax heightLevel  |
	heightLevel := aDistrict city height + 0.1 + aDistrict height .
	bxSize := x +1 .
	bzSize := z +1.
	zmax := 0.
	aDistrict buildings do: [:building |
		(dxSize < (bxSize+ (building width)))
		ifTrue: [
			bzSize := bzSize + zmax + self sourceCityGL configuration buildingGap.
			bxSize := x + 1.
			].
		(zmax<(building width))
		ifTrue:[zmax := (building width)].
		self building: building array: { bxSize . ( heightLevel ) . bzSize } width: (building width) height: (building height).
		bxSize := bxSize + self sourceCityGL configuration buildingGap + (building width).
	].
	^bzSize+zmax+1.! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 7/2/2012 15:24'!
drawCity: anImporter
	| width |
	width := self drawDistrict: anImporter city.
	self city: anImporter city 
		array: {-1 . -0.1 . -1} 
		x_width: width first 
		z_width: width second 
		color: anImporter city color.
	^width! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/28/2012 10:48'!
drawCube: anArray x_width: xwidth z_width: zwidth height: height.
	self drawFace: anArray x_width: xwidth z_width: zwidth height: height.
	self drawBack: anArray x_width: xwidth z_width: zwidth height: height.
	self drawLeft: anArray x_width: xwidth z_width: zwidth height: height.
	self drawRight: anArray x_width: xwidth z_width: zwidth height: height.
	self drawDown: anArray x_width: xwidth z_width: zwidth height: height.
	self drawTop: anArray x_width: xwidth z_width: zwidth height: height.! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 7/2/2012 15:08'!
drawDistrict:aCity
	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize buildingGap districtColor |
	x := 0.
	z := 0.
	maxdzSize := 0.
	maxdxSize := 0.
	buildingGap := self sourceCityGL configuration buildingGap.
	(self sourceCityGL configuration buildingGap < 1)
	ifTrue: [buildingGap := 1.] 
	ifFalse: [buildingGap := self sourceCityGL configuration buildingGap].
	aCity districts do:[:district |
		dxSize := x + ((district width) *buildingGap+1).
		dzSize := self drawBuilding: district x: x z: z dxSize: dxSize.
		self district: district array: { x . aCity height+0.1 . z } x_width: dxSize-x z_width: dzSize-z height: district height.
		
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		
		x := dxSize + self sourceCityGL configuration districtGap.
		( x > aCity width)
		ifTrue: [
			z := maxdzSize + self sourceCityGL configuration districtGap.
			(maxdxSize<x)
			ifTrue: [maxdxSize := x+(dxSize - x).].
			x := 0.
		]
		ifFalse: [
			(maxdxSize<x)
			ifTrue: [maxdxSize := x.].
		].
	].
	^{maxdxSize+2 . maxdzSize+2}! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/28/2012 10:41'!
drawDown: anArray x_width: xwidth z_width: zwidth height: height
	display gl begin: GL_QUADS;
		vertex3d_x:  anArray first 
			y: anArray second 
			z: anArray third;
		vertex3d_x:  (anArray first)+xwidth 
			y: anArray second
			z: anArray third;
		vertex3d_x:  (anArray first)+xwidth 
			y: anArray second
			z: (anArray third)+zwidth;
		vertex3d_x:  anArray first 
			y: anArray second
			z: (anArray third)+zwidth;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/28/2012 10:41'!
drawFace: anArray x_width: xwidth z_width: zwidth height: height
	display gl begin: GL_QUADS;
		vertex3d_x: anArray first 
			y: anArray second 
			z: anArray third;
		vertex3d_x: anArray first 
			y: anArray second + height
			z: anArray third;
		vertex3d_x: (anArray first)+xwidth 
			y: anArray second + height
			z: anArray third;
		vertex3d_x: (anArray first)+xwidth 
			y: anArray second 
			z: anArray third;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/28/2012 10:41'!
drawLeft: anArray x_width: xwidth z_width: zwidth height: height
	display gl begin: GL_QUADS;
		vertex3d_x:  (anArray first)+xwidth 
			y: anArray second
			z: anArray third;
		vertex3d_x:  (anArray first)+xwidth 
			y: anArray second + height
			z: anArray third;
		vertex3d_x:  (anArray first)+xwidth 
			y: anArray second + height
			z: (anArray third)+zwidth;
		vertex3d_x:  (anArray first)+xwidth 
			y: anArray second
			z: (anArray third)+zwidth;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/28/2012 10:40'!
drawRight: anArray x_width: xwidth z_width: zwidth height: height
	display gl begin: GL_QUADS;
		vertex3d_x:  anArray first 
			y: anArray second
			z: (anArray third)+zwidth;
		vertex3d_x:  anArray first 
			y: anArray second + height
			z: (anArray third)+zwidth;
		vertex3d_x:  anArray first 
			y: anArray second + height
			z: anArray third ;
		vertex3d_x:  anArray first 
			y: anArray second
			z: anArray third ;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/28/2012 10:42'!
drawTop: anArray x_width: xwidth z_width: zwidth height: height
	display gl begin: GL_QUADS;
		vertex3d_x: anArray first 
			y: anArray second + height
			z: anArray third ;
		vertex3d_x: anArray first 
			y: anArray second + height
			z: (anArray third)+zwidth;
		vertex3d_x: (anArray first)+xwidth 
			y: anArray second + height
			z: (anArray third)+zwidth;
		vertex3d_x: (anArray first)+xwidth 
			y: anArray second + height
			z: anArray third ;
	end.! !

!SourceCityGLDrawing methodsFor: 'initialize' stamp: 'DouailleErwan 6/21/2012 14:35'!
initialize
	super initialize.
	self pickingMode: false.
	! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:07'!
pickingMode
	^ pickingMode! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:07'!
pickingMode: anObject
	pickingMode := anObject! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 16:23'!
selectedElement
	^ self sourceCityGL selectedElement! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/22/2012 13:22'!
selectedElement: anObject
	^ self sourceCityGL selectedElement: anObject! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:08'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:08'!
sourceCityGL: anObject
	sourceCityGL := anObject! !

NBGLFrameBuffer subclass: #GLFrameBufferForPicking
	instanceVariableNames: 'texId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFrameBufferForPicking commentStamp: '<historical>' prior: 0!
Needed for picking!

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:39'!
attachTexture
	texId := WordArray new: 1.
	
" Create the texture object for the primitive information buffer "
	gl genTextures_n: 1 textures: texId.
	texId := texId at: 1.

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
	
	gl framebufferTexture2DEXT_target:  GL_DRAW_FRAMEBUFFER 
		attachment:  GL_COLOR_ATTACHMENT0 
		textarget: GL_TEXTURE_2D 
		texture:  texId  
		level: 0	.
	
	self assert: (gl getError = 0).
	gl bindTexture_target: GL_TEXTURE_2D texture: 0.! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:21'!
createAttachments

		" By default, create a RGBA8 and DEPTH24/STENCIL8 attachments "
	| color depthAndStencil |
	
	self attachTexture.

	
	depthAndStencil := NBGLRenderBuffer gl: gl extent: extent format: GL_DEPTH24_STENCIL8.
	self attach: depthAndStencil as: GL_DEPTH_ATTACHMENT.
	self attach: depthAndStencil as: GL_STENCIL_ATTACHMENT.
	
! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resize: newExtent

	"resize a frame buffer"
	extent = newExtent ifTrue: [ ^ self ].
	extent := newExtent.	

	self attachments do: [:renderBuffer | renderBuffer resize: newExtent  ].
	self resizeTexture.
	self checkStatus.

! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resizeTexture

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
! !

NBExternalStructure variableByteSubclass: #OpenGLListStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!OpenGLListStructure class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/3/2012 11:58'!
fieldsDesc
  ^ #( 
        )! !

Object subclass: #SourceCityGLCamera
	instanceVariableNames: 'xtran ytran ztran lastMousePosition sourceCityGL xrot yrot zrot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLCamera commentStamp: '<historical>' prior: 0!
I manage the camera and movements (do not contains key/mouse handler stuff)!

!SourceCityGLCamera class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/2/2012 17:03'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL.! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/26/2012 16:58'!
applyCamera
	 self sourceCityGL display gl translatef_x: self xtran y: self ytran z: self ztran.  
	 self sourceCityGL display gl  rotatef_angle:  self xrot x: 1 y: 0  z: 0. 
	 self sourceCityGL display gl rotatef_angle:  self yrot x: 0 y: 1  z: 0. 
	 self sourceCityGL display gl rotatef_angle:  self zrot x: 0 y: 0  z: 1. 
	 
! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/2/2012 16:53'!
cameraOnNormal
	xtran := 0.
	ytran := 0.
	ztran := 0-self sourceCityGL cityDimension first *7.
	xrot := -574.
	yrot := -747.
	zrot := 0.
	 ! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 7/2/2012 16:52'!
cameraOnTop
	xtran := 0.
	ytran := 0.
	ztran := 0-self sourceCityGL cityDimension first *7.
	xrot := -631.
	yrot := -900.
	zrot := 0.! !

!SourceCityGLCamera methodsFor: 'initialize' stamp: 'DouailleErwan 7/2/2012 17:01'!
initialize
	lastMousePosition := Point x: 0 y:0.
	xtran := 0.
	ytran := 0.
	ztran := -514.
	xrot := -574.
	yrot := -747.
	zrot := 0.
	 ! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 13:57'!
lastMousePosition
	^lastMousePosition ! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 13:53'!
lastMousePosition: aPoint
	lastMousePosition := aPoint! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/22/2012 15:39'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	fW := fH * aspect.
	self sourceCityGL display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/26/2012 16:56'!
rotateDown

	self xrot: self xrot + 3.
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/26/2012 16:56'!
rotateLeft

	self yrot: self yrot + 3.
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/26/2012 16:57'!
rotateRight

	self yrot: self yrot - 3.! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/26/2012 16:57'!
rotateTop

	self xrot: self xrot - 3.! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
sourceCityGL: anObject
	sourceCityGL := anObject! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:56'!
translateBackward

	self ztran: (self ztran - 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:56'!
translateDown

	self ytran: (self ytran + 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:57'!
translateForward

	self ztran: (self ztran + 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:57'!
translateLeft

	self xtran: (self xtran - 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:57'!
translateRight

	self xtran: (self xtran + 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:57'!
translateTop

	self ytran: (self ytran - 10).
	
	! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 16:56'!
xrot
	^ xrot! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 16:56'!
xrot: anObject
	xrot := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
xtran
	^ xtran! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
xtran: anObject
	xtran := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 16:56'!
yrot
	^ yrot! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 16:56'!
yrot: anObject
	yrot := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
ytran
	^ ytran! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
ytran: anObject
	ytran := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 16:56'!
zrot
	^ zrot! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 16:56'!
zrot: anObject
	zrot := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
ztran
	^ ztran! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
ztran: anObject
	ztran := anObject! !

Object subclass: #SourceCityGLController
	instanceVariableNames: 'sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLController commentStamp: '<historical>' prior: 0!
I manage and capture keyboard and mouse events!

!SourceCityGLController class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/21/2012 13:03'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/28/2012 10:17'!
captureKey: e
	(e keyString = '<left>')
		ifTrue:[ self sourceCityGL camera rotateLeft].
	(e keyString  = '<down>')
		ifTrue:[self sourceCityGL camera rotateDown].
	(e keyString  = '<up>')
		ifTrue:[self sourceCityGL camera rotateTop].
	(e keyString  = '<right>')
		ifTrue:[self sourceCityGL camera rotateRight].
	(e keyString  = '<Shift-right>')
		ifTrue:[self sourceCityGL camera translateRight].
	(e keyString  = '<Shift-left>')
		ifTrue:[self sourceCityGL camera translateLeft].
	(e keyString  = '<Shift-up>')
		ifTrue:[self sourceCityGL camera translateTop].
	(e keyString  = '<Shift-down>')
		ifTrue:[self sourceCityGL camera translateDown].
	(e keyString  = ' ')
		ifTrue:[self sourceCityGL camera translateForward].
	(e keyString  = 'c' )
		ifTrue:[self sourceCityGL camera translateBackward].
	(e keyString  = '<Cmd-w>' )
		ifTrue:[Transcript cr;show: ' dommage'].! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 7/3/2012 17:16'!
captureMouseDown: e
	self sourceCityGL drawing pickingMode: true.
	self sourceCityGL openglOption: false.
	self sourceCityGL drawing drawCity: self sourceCityGL importer.
	self picking_x: ((e position x) - self sourceCityGL position x) y: ((e position y) - self sourceCityGL position y).
	self sourceCityGL drawing pickingMode: false.! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/26/2012 17:04'!
captureMouseStillDown: e
	(self sourceCityGL camera  lastMousePosition x > (e position - self sourceCityGL position) x)
		ifTrue: [self sourceCityGL camera  rotateRight].
	(self sourceCityGL camera  lastMousePosition x < (e position - self sourceCityGL  position) x)
		ifTrue:[self sourceCityGL camera  rotateLeft].
	(self sourceCityGL camera  lastMousePosition y < (e position - self sourceCityGL position) y)
		ifTrue:[self sourceCityGL camera  rotateDown].
	(self sourceCityGL camera  lastMousePosition y > (e position - self sourceCityGL position) y)
		ifTrue:[self sourceCityGL camera  rotateTop].
	self sourceCityGL camera  lastMousePosition: (e position - self sourceCityGL position).! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/22/2012 15:29'!
handleMouseMove: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent wasHandled: true.
	anEvent anyButtonPressed ifTrue: [
		self captureMouseStillDown: anEvent
		].
! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/18/2012 15:26'!
hasKeyboardFocus
	^true.! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/26/2012 17:12'!
picking_x: x y: y
	|  pixel tmp |
	pixel := self sourceCityGL display readPixel: x@y.	
	tmp := (pixel at:1)*256 + (pixel at:2)*256 + (pixel at:3).
	(tmp = 0)
	ifTrue: [self sourceCityGL selectedElement: nil] 
	ifFalse: [self sourceCityGL selectedElement: (self searchPickingInformation: tmp)].
	self sourceCityGL userInterface getInformation.! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/26/2012 17:08'!
searchPickingInformation: aValue
	| informationDisplay |
	self sourceCityGL importer districts at: aValue 
		ifPresent: [ ^ self sourceCityGL importer districts at: aValue].
	self sourceCityGL importer buildings at: aValue 
		ifPresent: [ ^self sourceCityGL importer buildings at: aValue.] .
	^nil! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:39'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:39'!
sourceCityGL: anObject
	sourceCityGL := anObject! !
